diff -uprN turnserver-1.8.3.6.orig/centos/turnserver.init turnserver-1.8.3.6/centos/turnserver.init
--- turnserver-1.8.3.6.orig/centos/turnserver.init	1970-01-01 01:00:00.000000000 +0100
+++ turnserver-1.8.3.6/centos/turnserver.init	2013-05-04 22:54:48.044001115 +0100
@@ -0,0 +1,78 @@
+#!/bin/bash
+#
+# Startup script for TURN Server
+#
+# chkconfig: 345 85 15
+# description: RFC 5766 TURN Server
+#
+# processname: turnserver
+# pidfile: /var/run/turnserver.pid
+# config: /etc/turnserver/turnserver.conf
+#
+### BEGIN INIT INFO
+# Provides: turnserver
+# Required-Start: $local_fs $network
+# Short-Description: RFC 5766 TURN Server
+# Description: RFC 5766 TURN Server
+### END INIT INFO
+
+# Source function library.
+. /etc/rc.d/init.d/functions
+
+turn=/usr/bin/turnserver
+prog=turnserver
+pidfile=/var/run/$prog.pid
+lockfile=/var/lock/subsys/$prog
+user=turnserver
+RETVAL=0
+
+[ -f /etc/sysconfig/$prog ] && . /etc/sysconfig/$prog
+
+start() {
+	echo -n $"Starting $prog: "
+	# there is something at end of this output which is needed to
+	# report proper [ OK ] status in CentOS scripts
+	daemon --pidfile=$pidfile --user=$user $turn $OPTIONS
+	RETVAL=$?
+	echo
+	[ $RETVAL = 0 ] && touch $lockfile
+}
+
+stop() {
+	echo -n $"Stopping $prog: "
+	killproc $turn
+	RETVAL=$?
+	echo
+	[ $RETVAL = 0 ] && rm -f $lockfile $pidfile
+}
+
+[ -z "$OPTIONS" ] && OPTIONS="-c /etc/turnserver/turnserver.conf -o --no-stdout-log"
+
+# See how we were called.
+case "$1" in
+	start)
+		start
+		;;
+	stop)
+		stop
+		;;
+	status)
+		status $turn
+		RETVAL=$?
+		;;
+	restart)
+		stop
+		start
+		;;
+	condrestart)
+		if [ -f /var/run/$prog.pid ] ; then
+			stop
+			start
+		fi
+		;;
+	*)
+		echo $"Usage: $prog {start|stop|restart|condrestart|status|help}"
+		exit 1
+esac
+
+exit $RETVAL
diff -uprN turnserver-1.8.3.6.orig/centos/turnserver.sysconfig turnserver-1.8.3.6/centos/turnserver.sysconfig
--- turnserver-1.8.3.6.orig/centos/turnserver.sysconfig	1970-01-01 01:00:00.000000000 +0100
+++ turnserver-1.8.3.6/centos/turnserver.sysconfig	2013-05-04 22:52:41.819999834 +0100
@@ -0,0 +1,5 @@
+#
+# TURN Server startup options
+#
+
+OPTIONS="-c /etc/turnserver/turnserver.conf -o --no-stdout-log"
diff -uprN turnserver-1.8.3.6.orig/configure turnserver-1.8.3.6/configure
--- turnserver-1.8.3.6.orig/configure	2013-05-01 06:49:50.000000000 +0100
+++ turnserver-1.8.3.6/configure	2013-05-04 22:34:01.322999200 +0100
@@ -183,6 +183,10 @@ if [ -z "${MANPREFIX}" ] ; then
 	MANPREFIX=${PREFIX}
 fi
 
+if [ -z "${CONFPREFIX}" ] ; then
+	CONFPREFIX=${PREFIX}/etc
+fi
+
 if [ -z "${EXAMPLESDIR}" ] ; then
 	EXAMPLESDIR=${PREFIX}/share/examples/${PORTNAME}
 fi
@@ -642,6 +646,7 @@ echo "#" >> Makefile
 echo "PORTNAME = ${PORTNAME}" >> Makefile
 echo "PREFIX = ${PREFIX}" >> Makefile
 echo "MANPREFIX = ${MANPREFIX}" >> Makefile
+echo "CONFPREFIX = ${CONFPREFIX}" >> Makefile
 echo "EXAMPLESDIR = ${EXAMPLESDIR}" >> Makefile
 echo "DOCSDIR = ${DOCSDIR}" >> Makefile
 echo "LIBDIR = ${LIBDIR}" >> Makefile
diff -uprN turnserver-1.8.3.6.orig/Makefile.in turnserver-1.8.3.6/Makefile.in
--- turnserver-1.8.3.6.orig/Makefile.in	2013-05-01 06:49:50.000000000 +0100
+++ turnserver-1.8.3.6/Makefile.in	2013-05-04 22:34:08.076994550 +0100
@@ -105,64 +105,63 @@ distclean:	clean
 ### Install all:
 
 install:	all ${MAKE_DEPS}
-	${MKDIR} ${PREFIX}
-	${MKDIR} ${PREFIX}/bin
-	${MKDIR} ${MANPREFIX}/man/man1
-	${MKDIR} ${PREFIX}/etc
-	${MKDIR} ${LIBDIR}
-	${MKDIR} ${EXAMPLESDIR}
-	${MKDIR} ${DOCSDIR}
-	${MKDIR} ${SCHEMADIR}
-	${MKDIR} ${TURNINCLUDEDIR}
-	${INSTALL_PROGRAM} bin/turnserver ${PREFIX}/bin/
-	${INSTALL_PROGRAM} bin/turnadmin ${PREFIX}/bin/
-	${INSTALL_PROGRAM} bin/turnutils_uclient ${PREFIX}/bin/
-	${INSTALL_PROGRAM} bin/turnutils_peer ${PREFIX}/bin/
-	${INSTALL_PROGRAM} bin/turnutils_stunclient ${PREFIX}/bin/
-	${INSTALL_PROGRAM} bin/turnutils_rfc5769check ${PREFIX}/bin/
-	${INSTALL_MAN} man/man1/turnserver.1 ${MANPREFIX}/man/man1/
-	${INSTALL_MAN} man/man1/turnadmin.1 ${MANPREFIX}/man/man1/
-	${INSTALL_MAN} man/man1/turnutils.1 ${MANPREFIX}/man/man1/
-	${INSTALL_MAN} man/man1/turnutils_uclient.1 ${MANPREFIX}/man/man1/
-	${INSTALL_MAN} man/man1/turnutils_rfc5769check.1 ${MANPREFIX}/man/man1/
-	${INSTALL_MAN} man/man1/turnutils_stunclient.1 ${MANPREFIX}/man/man1/
-	${INSTALL_MAN} man/man1/turnutils_peer.1 ${MANPREFIX}/man/man1/
-	${INSTALL_STATIC_LIB} lib/libturnclient.a ${LIBDIR}
-	${INSTALL_DIR} docs/html ${DOCSDIR}
-	${INSTALL_DATA} docs/TURNServerRESTAPI.pdf ${DOCSDIR}
-	${INSTALL_DATA} docs/TurnNetworks.pdf ${DOCSDIR}
-	${INSTALL_DATA} README.turnserver ${DOCSDIR}
-	${INSTALL_DATA} README.turnadmin ${DOCSDIR}
-	${INSTALL_DATA} README.turnutils ${DOCSDIR}
-	${INSTALL_DATA} INSTALL ${DOCSDIR}
-	${INSTALL_DATA} postinstall.txt ${DOCSDIR}
-	${INSTALL_DATA} turndb/schema.sql ${DOCSDIR}
-	${INSTALL_DATA} turndb/schema.sql ${SCHEMADIR}
-	${INSTALL_DATA} examples/etc/turnserver.conf ${PREFIX}/etc/turnserver.conf.default
-	${INSTALL_DATA} examples/etc/turnuserdb.conf ${PREFIX}/etc/turnuserdb.conf.default
-	${INSTALL_DIR} examples/etc ${EXAMPLESDIR}
-	${INSTALL_DIR} examples/scripts ${EXAMPLESDIR}
-	${INSTALL_DIR} include/turn/client ${TURNINCLUDEDIR}
-	${INSTALL_DATA} include/turn/ns_turn_defs.h ${TURNINCLUDEDIR}
-	${MORECMD} ${DOCSDIR}/postinstall.txt
+	${MKDIR} ${DESTDIR}${PREFIX}
+	${MKDIR} ${DESTDIR}${PREFIX}/bin
+	${MKDIR} ${DESTDIR}${MANPREFIX}/man/man1
+	${MKDIR} ${DESTDIR}${CONFPREFIX}/turnserver
+	${MKDIR} ${DESTDIR}${LIBDIR}
+	${MKDIR} ${DESTDIR}${EXAMPLESDIR}
+	${MKDIR} ${DESTDIR}${DOCSDIR}
+	${MKDIR} ${DESTDIR}${SCHEMADIR}
+	${MKDIR} ${DESTDIR}${TURNINCLUDEDIR}
+	${INSTALL_PROGRAM} bin/turnserver ${DESTDIR}${PREFIX}/bin/
+	${INSTALL_PROGRAM} bin/turnadmin ${DESTDIR}${PREFIX}/bin/
+	${INSTALL_PROGRAM} bin/turnutils_uclient ${DESTDIR}${PREFIX}/bin/
+	${INSTALL_PROGRAM} bin/turnutils_peer ${DESTDIR}${PREFIX}/bin/
+	${INSTALL_PROGRAM} bin/turnutils_stunclient ${DESTDIR}${PREFIX}/bin/
+	${INSTALL_PROGRAM} bin/turnutils_rfc5769check ${DESTDIR}${PREFIX}/bin/
+	${INSTALL_MAN} man/man1/turnserver.1 ${DESTDIR}${MANPREFIX}/man/man1/
+	${INSTALL_MAN} man/man1/turnadmin.1 ${DESTDIR}${MANPREFIX}/man/man1/
+	${INSTALL_MAN} man/man1/turnutils.1 ${DESTDIR}${MANPREFIX}/man/man1/
+	${INSTALL_MAN} man/man1/turnutils_uclient.1 ${DESTDIR}${MANPREFIX}/man/man1/
+	${INSTALL_MAN} man/man1/turnutils_rfc5769check.1 ${DESTDIR}${MANPREFIX}/man/man1/
+	${INSTALL_MAN} man/man1/turnutils_stunclient.1 ${DESTDIR}${MANPREFIX}/man/man1/
+	${INSTALL_MAN} man/man1/turnutils_peer.1 ${DESTDIR}${MANPREFIX}/man/man1/
+	${INSTALL_STATIC_LIB} lib/libturnclient.a ${DESTDIR}${LIBDIR}
+	${INSTALL_DIR} docs/html ${DESTDIR}${DOCSDIR}
+	${INSTALL_DATA} docs/TURNServerRESTAPI.pdf ${DESTDIR}${DOCSDIR}
+	${INSTALL_DATA} docs/TurnNetworks.pdf ${DESTDIR}${DOCSDIR}
+	${INSTALL_DATA} README.turnserver ${DESTDIR}${DOCSDIR}
+	${INSTALL_DATA} README.turnadmin ${DESTDIR}${DOCSDIR}
+	${INSTALL_DATA} README.turnutils ${DESTDIR}${DOCSDIR}
+	${INSTALL_DATA} INSTALL ${DESTDIR}${DOCSDIR}
+	${INSTALL_DATA} postinstall.txt ${DESTDIR}${DOCSDIR}
+	${INSTALL_DATA} turndb/schema.sql ${DESTDIR}${DOCSDIR}
+	${INSTALL_DATA} turndb/schema.sql ${DESTDIR}${SCHEMADIR}
+	${INSTALL_DATA} examples/etc/turnserver.conf ${DESTDIR}${CONFPREFIX}/turnserver/turnserver.conf
+	${INSTALL_DATA} examples/etc/turnuserdb.conf ${DESTDIR}${CONFPREFIX}/turnserver/turnuserdb.conf
+	${INSTALL_DIR} examples/etc ${DESTDIR}${EXAMPLESDIR}
+	${INSTALL_DIR} examples/scripts ${DESTDIR}${EXAMPLESDIR}
+	${INSTALL_DIR} include/turn/client ${DESTDIR}${TURNINCLUDEDIR}
+	${INSTALL_DATA} include/turn/ns_turn_defs.h ${DESTDIR}${TURNINCLUDEDIR}
+#	${MORECMD} ${DESTDIR}${DOCSDIR}/postinstall.txt
 
 deinstall:	${MAKE_DEPS}
-	${RMCMD} ${DOCSDIR}
-	${RMCMD} ${SCHEMADIR}
-	${RMCMD} ${PREFIX}/bin/turnserver
-	${RMCMD} ${PREFIX}/bin/turnadmin
-	${RMCMD} ${PREFIX}/bin/turnutils_peer
-	${RMCMD} ${PREFIX}/bin/turnutils_uclient
-	${RMCMD} ${PREFIX}/bin/turnutils_rfc5769check
-	${RMCMD} ${PREFIX}/bin/turnutils_stunclient
-	${RMCMD} ${MANPREFIX}/man/man1/turnserver.1
-	${RMCMD} ${MANPREFIX}/man/man1/turnadmin.1
-	${RMCMD} ${MANPREFIX}/man/man1/turnutils.1
-	${RMCMD} ${LIBDIR}/libturnclient.a
-	${RMCMD} ${EXAMPLESDIR}/
-	${RMCMD} ${PREFIX}/etc/turnserver.conf.default
-	${RMCMD} ${PREFIX}/etc/turnuserdb.conf.default
-	${RMCMD} ${TURNINCLUDEDIR}
+	${RMCMD} ${DESTDIR}${DOCSDIR}
+	${RMCMD} ${DESTDIR}${SCHEMADIR}
+	${RMCMD} ${DESTDIR}${PREFIX}/bin/turnserver
+	${RMCMD} ${DESTDIR}${PREFIX}/bin/turnadmin
+	${RMCMD} ${DESTDIR}${PREFIX}/bin/turnutils_peer
+	${RMCMD} ${DESTDIR}${PREFIX}/bin/turnutils_uclient
+	${RMCMD} ${DESTDIR}${PREFIX}/bin/turnutils_rfc5769check
+	${RMCMD} ${DESTDIR}${PREFIX}/bin/turnutils_stunclient
+	${RMCMD} ${DESTDIR}${MANPREFIX}/man/man1/turnserver.1
+	${RMCMD} ${DESTDIR}${MANPREFIX}/man/man1/turnadmin.1
+	${RMCMD} ${DESTDIR}${MANPREFIX}/man/man1/turnutils.1
+	${RMCMD} ${DESTDIR}${LIBDIR}/libturnclient.a
+	${RMCMD} ${DESTDIR}${EXAMPLESDIR}/
+	${RMCMD} ${DESTDIR}${CONFPREFIX}/turnserver
+	${RMCMD} ${DESTDIR}${TURNINCLUDEDIR}
 
 uninstall:	deinstall
 